% Edelsbrunner and Herbert, "Algorithms in Combinatorial Geometry", 1987.
% 
% ack-h(0,Y,Z) = Y+Z
% ack-h(X,Y,0) = 0
% ack-h(X,Y,1) = Y
% ack-h(X,Y,Z) = ack-h( X-1 ,Y , ack-h(X,Y,Z-1) )

ackermann1(X1,Y,Z1,A1) :- ack1(X1,Y,Z1,A1).
ack1(X1,Y,Z1,A1) :- X1=0, A1=Y+Z1.
ack1(X1,Y,Z1,A1) :- X1>=1, Z1=0, A1=0.
ack1(X1,Y,Z1,A1) :- X1>=1, Z1=1, A1=Y.
ack1(X1,Y,Z1,A1) :- X1>=1, Z1>=2, X2=X1-1, Z2=Z1-1, 
  ack1(X1,Y,Z2,A), ack1(X2,Y,A,A1).

ackermann_pr3(X,Y,Z,Y,Z) :- X=< 0.
ackermann_pr3(X,Y,Z,Y1,Z) :- X>=1,Z=0, Y1=0.  
ackermann_pr3(X,Y,Z,Y1,Z) :- X>=1,Z=1, Y1=Y-1.  % Y1=Y, Z1=0 
ackermann_pr3(X,Y,Z,Y2,Z2) :- X>=1, Z=\= 0, Z=\= 1, Zm1=Z-1, Z1=Y3+Z3, X1=X-1,
  ackermann_pr3(X,Y,Zm1,Y3,Z3), ackermann_pr3(X1,Y,Z1,Y2,Z2).
ackermann2(X,Y,Z,A) :- A= Y1+Z1, ackermann_pr3(X,Y,Z,Y1,Z1).

incorrect :- X=X2, Y=Y2, Z=Z2, A=\=A2, ackermann1(X,Y,Z,A), ackermann2(X2,Y2,Z2,A2).	
