% Rosza Peter (also called Rosa Politzer)  version
% base case 2*N+1  instead of N+1

ackermann1(M1,N1,A1) :- ack1(M1,N1,A1).
ack1(M1,N1,A1) :- M1=0, A1=2*N1+1.
ack1(M1,N1,A1) :- M1>=1, N1=0, X1=M1-1, Y1=1, ack1(X1,Y1,A1).
ack1(M1,N1,A1) :- M1>=1, N1>=1, X1=M1-1, Y1=N1-1, ack1(M1,Y1,Z1), ack1(X1,Z1,A1).

ackermann_pr3(D,E,E) :- D=< 0.
ackermann_pr3(D,E,J) :- K= -1+D, L= 1, E= 0, D>= 1, ackermann_pr3(K,L,J).
ackermann_pr3(D,E,J) :- K= -1+E, L= -1+D, 2*M= -1+N,  1-D=< 0, E=\= 0, 
          ackermann_pr3(D,K,M), ackermann_pr3(L,N,J).
ackermann2(A,B,C) :- 2*D= -1+C, ackermann_pr3(A,B,D).

incorrect :- M1=M2, N1=N2, A1=\=A2, ackermann1(M1,N1,A1), ackermann2(M2,N2,A2).
